classification
Title: Python 3.5.1 installer fails on Windows 7
Type: Stage: resolved
Components: Windows Versions: Python 3.5
process
Status: closed Resolution: out of date
Dependencies: Superseder: Change Windows install to applocal UCRT
View: 32507
Assigned To: Nosy List: eryksun, nedbat, paul.moore, steve.dower, tim.golden, zach.ware
Priority: normal Keywords:

Created on 2015-12-26 03:27 by nedbat, last changed 2018-01-06 23:59 by steve.dower. This issue is now closed.

Files
File name Uploaded Description Edit
Python 3.5.1 logs.zip nedbat, 2015-12-26 03:27
Python 3.5.1 more logs.zip nedbat, 2015-12-27 10:34
Messages (9)
msg257017 - (view) Author: Ned Batchelder (nedbat) * (Python triager) Date: 2015-12-26 03:27
I tried to install 3.5.1 32-bit into a fresh virtualbox image from https://dev.windows.com/en-us/microsoft-edge/tools/vms/mac/ (IE 10 on Win 7), and got this error message.  When I try to run Python with "py -3", it will not run, it only shows:

                    ---------------------------
                    python.exe - System Error
                    ---------------------------
                    The program can't start because api-ms-win-crt-runtime-l1-1-0.dll is missing from your computer. Try reinstalling the program to fix this problem. 
                    ---------------------------
                    OK   
                    ---------------------------

I tried repairing the installation (with the control panel), which did not help.

I've attached the log files created by the installer.
msg257019 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2015-12-26 07:37
The main log file reports that installing the CRT exited with the code ERROR_INSTALL_ALREADY_RUNNING (0x652): 

    Another installation is already in progress. 
    Complete that installation before proceeding 
    with this install.

You may need to completely reinstall to have it retry installing the CRT update.
msg257031 - (view) Author: Ned Batchelder (nedbat) * (Python triager) Date: 2015-12-26 13:07
This was my second attempt, and there is no other installation running.
msg257035 - (view) Author: Ned Batchelder (nedbat) * (Python triager) Date: 2015-12-26 14:20
This is in a virtualbox. I have my host OS files mapped in the guest Windows OS to drive N:.   When I try to install by running N:\Downloads\python-3.5.1.exe, it fails with the error shown above.  When I copy the file to the C: drive, it succeeds! ?
msg257041 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2015-12-26 17:16
Packages are installed from the ProgramData folder on the system volume. For example, the log shows the CRT update executed as follows:

    "C:\Windows\system32\wusa.exe" "C:\ProgramData\Package Cache\
    D4036846864773E3D647F421DFE7F6CA536E307B\
    Windows6.1-KB2999226-x86.msu" /quiet /norestart

Is it installing from the same ProgramData directory when it succeeds?
msg257068 - (view) Author: Ned Batchelder (nedbat) * (Python triager) Date: 2015-12-27 10:34
I'm attaching another bunch of logs.  There seem to be two installations here, one of which succeeded.
msg258412 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2016-01-16 21:15
Sorry for letting this slide for a while...

Can you check (in Programs and Features, View Installed Updates) whether you have KB2999226 installed? If not, you can get it from https://support.microsoft.com/en-us/kb/2999226

In the first install, this component failed (hence the missing DLL error), and then in subsequent installs it wasn't re-run. I'm not sure exactly what happened here, but it's possible that the installation was deferred until the next reboot automatically. Being a Windows Update, we don't have much control over how these are managed and the operating system can basically do what it likes.
msg258465 - (view) Author: Ned Batchelder (nedbat) * (Python triager) Date: 2016-01-17 12:27
Steve, I do have that update installed.
msg258471 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2016-01-17 14:32
Is your installation working okay then? You seemed to imply that in an earlier message, but I just want to confirm before closing the issue.
History
Date User Action Args
2018-01-06 23:59:26steve.dowersetstatus: open -> closed
superseder: Change Windows install to applocal UCRT
resolution: out of date
stage: resolved
2016-01-17 14:32:46steve.dowersetmessages: + msg258471
2016-01-17 12:27:45nedbatsetmessages: + msg258465
2016-01-16 21:15:41steve.dowersetmessages: + msg258412
2015-12-27 10:34:04nedbatsetfiles: + Python 3.5.1 more logs.zip

messages: + msg257068
2015-12-26 17:16:58eryksunsetmessages: + msg257041
2015-12-26 14:20:17nedbatsetmessages: + msg257035
2015-12-26 13:07:47nedbatsetmessages: + msg257031
2015-12-26 07:37:22eryksunsetnosy: + eryksun
messages: + msg257019
2015-12-26 03:27:22nedbatcreate